#include <bits/stdc++.h>
using namespace std;
#define int long long

struct Node_MAX {
    int val=0, d=-1, pl=0;
};


struct Seg_Tree_MAX {
    vector<Node_MAX>t, a;

    Node_MAX merge_MAX(Node_MAX &a, Node_MAX &b) {
        Node_MAX c;
        c.val = max(a.val , b.val);
        return c;
    }

    void build(int v, int tl, int tr) {
        if (tl + 1 == tr) {
            t[v] = a[tl];
            return;
        }
        int m=(tl+tr)/2;
        build(v*2, tl, m);
        build(v*2+1, m, tr);
        t[v]=merge_MAX(t[v*2], t[v*2+1]);
    }

    void push(int v, int tl, int tr) {
        int m = (tl+tr)/2;
        int d=t[v].d, pl=t[v].pl;
        //if (v==3) cerr<<"PUSH " << v << ' ' << tl << ' ' << tr << ' ' << d << ' ' << pl << '\n';
        if (d != -1) {
            t[v*2].val=d;
            t[v*2].val += pl;
            t[v*2].d=d;
            t[v*2].pl=pl;

            t[v*2+1].val=d;
            t[v*2+1].val+=pl;
            t[v*2+1].d=d;
            t[v*2+1].pl=pl;
        } else {
            t[v*2].val += pl;
            t[v*2].pl+=pl;

            t[v*2+1].val += pl;
            t[v*2+1].pl += pl;
        }

        t[v].d=-1;
        t[v].pl=0;
    }

    void upd(int v, int tl, int tr, int ql, int qr, int type, int x) {
        if (tr <= ql || tl >= qr) {
            return;
        }
        //cerr<<"U : " << v<<' ' <<tl << ' ' << tr << ' ' << ql << ' ' << qr << '\n';
        if (ql <= tl && tr <= qr) {
            //if (ql==3 && qr==8) cerr<<"UPD : " << v<<' ' <<tl << ' ' << tr << ' ' << ql << ' ' << qr << '\n';
            if (type == 1) {
                if (t[v].d == -1) {
                    t[v].val+=x;
                    t[v].pl+=x;
                } else {
                    t[v].d += x;
                    t[v].val += x;
                }
            } else {
                t[v].val=x;
                t[v].pl=0;
                t[v].d=x;
            }
            return;
        }
        push(v, tl, tr);
        int m=(tl+tr)/2;
        upd(v*2, tl, m, ql, qr, type, x);
        upd(v*2+1, m, tr, ql, qr, type, x);
        t[v]=merge_MAX(t[v*2], t[v*2+1]);
    }

    int get(int v, int tl, int tr, int ql, int qr) {
        if (tr <= ql || tl >= qr) {
            return -1;
        }
        push(v, tl, tr);

        if (ql <= tl && tr <= qr) {
            return t[v].val;
        }
        int m=(tl+tr)/2;
        return max(get(v*2, tl, m, ql, qr),get(v*2+1, m, tr, ql, qr));
    }
};




signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int>h(n+1);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    vector<int>k(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> k[i];
    }

    vector<int>res(n, 0);


    Seg_Tree_MAX FIND_K;
    vector<Node_MAX>s(n);
    for (int i = 0; i < n; ++i) {
        s[i].val=i+1;
    }
    FIND_K.a=s;
    FIND_K.t.resize(4*n);
    FIND_K.build(1, 0, n);

    for (auto q : k) {
        int l=-1, r=n;
        int L1;
        while (r-l>1) {
            int m=(l+r)/2;
            if (FIND_K.get(1, 0, n, 0, m) >= q) {
                r=m;
            } else {
                l = m;
            }
        }
        L1=r;
        l=0, r=n+1;
        while (r-l>1) {
            int m=(l+r)/2;
            if (FIND_K.get(1, 0, n, 0, m) <= q+1) {
                l=m;
            } else {
                r = m;
            }
        }


        int R2=l;
        l=0, r=n+1;
        while (r-l>1) {
            int m=(l+r)/2;
            if (FIND_K.get(1, 0, n, 0, m) <= q) {
                l=m;
            } else {
                r = m;
            }
        }
        //cout<<FIND_K.get(1, 0, n, R2, R2+1) << "   ";
        int R1=l;
        int L2=R1+1;

        L1--;
        //cout << FIND_K.get(1, 0, n, 0, L1+1) << "    ";
        R1--;
        L2--;
        R2--;

        deque<int>pr;
        for (int j = R2; j >= L1; --j) {
            if (j==R2) {
                pr.push_back(h[j]);
            } else {
                pr.push_front(max(h[j], pr.front()));
            }
        }
        int mx=-1;
        int sum=0;

        for (int j=L1;j<=R2;++j) {
            mx=max(mx,h[j]);
            res[j]=min(mx, pr.front())-h[j];
            sum+=res[j];
            pr.pop_front();
        }
        cout<<sum<<'\n';
        FIND_K.upd(1, 0, n, L2, n, 1, -1);

    }
}